const { errors } = require('cozy-konnector-libs')
const { findUserPdl } = require('../src/findUserPdl')

var mockParsePdl: jest.Mock

jest.mock('../src/parsing', () => ({
  parseUserPdl: mockParsePdl = jest.fn(),
}))

describe('recherchePoint', () => {
  it('should throw LOGIN_FAILED for too many responses', async () => {
    mockParsePdl.mockImplementationOnce(() => {
      throw new Error('fail')
    })

    try {
      const result = await findUserPdl(
        'azertyuiop',
        'apiKey',
        'login@user.com',
        'John',
        '1 street',
        '69069',
        '69069'
      )
      console.log('result: ' + result)
      expect(true).toBe(false)
    } catch (error) {
      console.log('error in test file ' + error)
      expect(error).toBe(errors.LOGIN_FAILED)
    }
  })

  it('should return a correct pdl number', async () => {
    mockParsePdl.mockResolvedValue('12345')
    expect(
      await findUserPdl(
        'azertyuiop',
        'apiKey',
        'login@user.com',
        'John',
        '1 street',
        '69069',
        '69069'
      )
    ).toBe('12345')
  })
})
